import { PluginStateObject } from "../../mol-plugin-state/objects";

export type PMS = PluginStateObject.Molecule.Structure;

type PDBTMChainLabel = string;
type PDBTMChain = {
    chain_label: PDBTMChainLabel,
    additional_chain_annotations: {
        type: string,
        num_tm: number
    },
    residues: {
        pdb_res_label?: string,
        aa_type?: string,
        site_data?: { site_id_ref: number, confidence_classification: string }[]
    }[]
};
export type PDBTMRegion = { site: string, auth_ids: number[], color: number[] };
export type PDBTMVec3 = { x: number, y: number, z: number };
type PDBTMTransformationMatrixRow = { x: number, y: number, z: number, t: number };
export type PDBTMTransformationMatrix = {
    rowx: PDBTMTransformationMatrixRow,
    rowy: PDBTMTransformationMatrixRow,
    rowz: PDBTMTransformationMatrixRow
};
export type PDBTMDescriptor = {
    pdb_id: string,
    chains: PDBTMChain[],
    site: { site_id: number, label: string }[],
    additional_entry_annotations: {
        membrane: {
            normal: PDBTMVec3,
            transformation_matrix: PDBTMTransformationMatrix,
            radius: number
        },
        biomatrix: {
            chain_deletes: string[],
            matrix_list: {
                matrix_id: string,
                apply_to_chain_list: {
                    chain_id: PDBTMChainLabel,
                    new_chain_id: PDBTMChainLabel
                }[],
                transformation_matrix: PDBTMTransformationMatrix
            }[]
        }
    }
};

// type TrajectoryType = StateObjectSelector<
//     PluginStateObject.Molecule.Trajectory,
//     StateTransformer<StateObject<any, StateObject.Type<any>>,
//     StateObject<any, StateObject.Type<any>>, any>
// >;
